%global _hardened_build 1
%{!?_syprefix: %define _syprefix /opt/symas }
%{!?_etcfix: %define _etcfix %{_syprefix}/etc }
%{!?_sylibdir: %define _sylibdir %{_syprefix}/lib }
%{!?_varfix: %define _varfix /var/symas }

Name:		symas-heimdal
Version:	7.8.0
Release:	2%{?dist}
Summary:	Symas's Heimdal Kerberos build
License:	BSD
URL:		https://github.com/heimdal/
VCS:		https://git.symas.net/symas-public/heimdal.git
Source:	    %{name}-%{version}.tar.gz
BuildRequires: gcc, make, sqlite-devel, python3, byacc
BuildRequires: ncurses-devel, autoconf, automake, flex
BuildRequires: symas-openssl-devel
%if 0%{?suse_version}
BuildRequires: perl
%else
BuildRequires: perl-interpreter
%endif
BuildRequires: libtool, perl(JSON)

%description
The Symas Heimdal Kerberos build for additional encryption services

%package libs
Summary:        Heimdal Libaries
Requires: symas-openssl-libs
%if 0%{?suse_version}
Requires: libncurses6, libsqlite3-0
%else
%if 0%{?centos_ver} && 0%{?centos_ver} == 7
Requires: sqlite
%else
Requires: sqlite-libs
%endif
Requires: ncurses-libs
%endif
AutoReqProv:        no

%description libs
The symas-heimdal-libs package contains the heimdal libraries

%package devel
Summary:        Heimdal Development
Requires: symas-heimdal-libs = %{version}-%{release}
AutoReqProv:        no

%description devel
The symas-heimdal-devel package contains the linking libraries and include files

%prep
%setup -qn heimdal-%{version}

%build
autoreconf -f -i
%if 0%{?suse_version}
LDFLAGS="-L%{_sylibdir} -Wl,-rpath,%{_sylibdir}" \
%else
LDFLAGS="%{__global_ldflags} -L%{_sylibdir} -Wl,-rpath,%{_sylibdir}" \
%endif
CFLAGS="%{optflags} -D_REENTRANT" \
CXXFLAGS="%{optflags} -D_REENTRANT" \
CPPFLAGS=-I%{_syprefix}/include \
./configure --prefix=%{_syprefix} \
    --sysconfdir=%{_etcfix}/heimdal \
    --localstatedir=%{_varfix} \
    --libexecdir=%{_sylibdir} \
    --datadir=%{_varfix} \
    --enable-shared \
    --enable-pthread-support \
    --disable-berkeley-db \
    --disable-ndbm-db \
    --disable-afs-support \
    --without-readline \
    --without-openldap \
    --without-hesiod \
    --with-sqlite3=/usr \
    --enable-static=no

make -C include
make -C lib/roken
make -C lib/vers
make -C lib/com_err
make -C lib/base
make -C lib/asn1
make -C lib/libedit
make -C lib/sl
make -C lib/hcrypto
make -C lib/wind
make -C lib/hx509
make -C lib/ipc
make -C lib/krb5
make -C lib/ntlm
make -C lib/gssapi
make -C lib/hdb
make -C lib/kadm5

%install
make -C include install DESTDIR=%{buildroot}
make -C lib/base install DESTDIR=%{buildroot}
make -C lib/roken install DESTDIR=%{buildroot}
make -C lib/com_err install DESTDIR=%{buildroot}
make -C lib/asn1 install DESTDIR=%{buildroot}
make -C lib/libedit install DESTDIR=%{buildroot}
make -C lib/sl install DESTDIR=%{buildroot}
make -C lib/hcrypto install DESTDIR=%{buildroot}
make -C lib/wind install DESTDIR=%{buildroot}
make -C lib/hx509 install DESTDIR=%{buildroot}
make -C lib/ipc install DESTDIR=%{buildroot}
make -C lib/krb5 install DESTDIR=%{buildroot}
make -C lib/ntlm install DESTDIR=%{buildroot}
make -C lib/hdb install DESTDIR=%{buildroot}
make -C lib/kadm5 install DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_syprefix}/share/man/cat5/mech
mkdir -p %{buildroot}%{_syprefix}/share/man/man5/mech
mkdir -p %{buildroot}%{_syprefix}/share/doc/heimdal
make -C lib/gssapi install DESTDIR=%{buildroot}
rm -rf %{buildroot}%{_syprefix}/bin
rm -rf %{buildroot}%{_syprefix}/libexec
rm -rf %{buildroot}%{_syprefix}/sbin
rm -rf %{buildroot}%{_syprefix}/share/man/man7
rm -rf %{buildroot}%{_syprefix}/share/man/man8
rm -f %{buildroot}%{_syprefix}/share/man/man5/mech.5
rm -f %{buildroot}%{_syprefix}/share/man/man5/qop.5
rm -f %{buildroot}%{_sylibdir}/*.la
rm -rf %{buildroot}%{_sylibdir}/heimdal*
rm -f %{buildroot}%{_sylibdir}/ipropd-master
rm -f %{buildroot}%{_sylibdir}/ipropd-slave
install -m 0644 ChangeLog %{buildroot}%{_syprefix}/share/doc/heimdal
install -m 0644 LICENSE %{buildroot}%{_syprefix}/share/doc/heimdal
install -m 0644 NEWS %{buildroot}%{_syprefix}/share/doc/heimdal
install -m 0644 README %{buildroot}%{_syprefix}/share/doc/heimdal

%files libs
%defattr(-,root,root)
%{_sylibdir}/*.so.*
%{_syprefix}/share/man/man5
%{_syprefix}/share/doc/heimdal

%files devel
%defattr(-,root,root)
%{_sylibdir}/*.so
%{_syprefix}/include
%{_syprefix}/share/man/man3

%changelog
* Thu Jan 19 2023 Symas Support <support@symas.com> - 7.8.0-2
- Hardened build in spec file
* Fri Dec 16 2022 Symas Support <support@symas.com> - 7.8.0-1
- Heimdal 7.8.0-1 release bits
* Thu Sep 8 2022 Symas Support <support@symas.com> - 7.7.0-6
- Add patch for upstream issue#431 lib/ipc: client double close of socket file descriptor
* Tue Nov 16 2021 Symas Support <support@symas.com> - 7.7.0-5
- Packaging ChangeLog, LICENSE, NEWS, and README files
* Wed Jun 09 2021 Symas Support <support@symas.com> - 7.7.0-4
- Add patch for upstream issue#776 - Fix ASN1 OID for SHA-384
* Mon May 24 2021 Symas Support <support@symas.com> - 7.7.0-3
- Update paths for odd Symas Gold locations
* Tue May 11 2021 Symas Support <support@symas.com> - 7.7.0-2
- FHS fixups
* Tue Apr 6 2021 Symas Support <support@symas.com> - 7.7.0-1
- initial packaging
